Index: explore/J1c.py
===================================================================
--- explore/J1c.py	(revision e6f14104e82489f43d4acc1eeda0d50ad5408fb6)
+++ explore/J1c.py	(revision 0a6da3c2133a98c9475f95364de124e647838b54)
@@ -8,14 +8,14 @@
 import pylab
 
-mp.dps = 150 # number of digits to use in estimating true value
 
 SHOW_DIFF = True  # True if show diff rather than function value
 LINEAR_X = False  # True if q is linearly spaced instead of log spaced
 
-def mp_J1c(vec):
+def mp_J1c(vec, bits=500):
     """
     Direct calculation using sympy multiprecision library.
     """
-    return [_mp_J1c(mp.mpf(x)) for x in vec]
+    with mp.workprec(bits):
+        return [_mp_J1c(mp.mpf(x)) for x in vec]
 
 def _mp_J1c(x):
@@ -25,16 +25,17 @@
     return mp.mpf(2)*mp.j1(x)/x
 
-def np_j1c(x, dtype):
+def np_J1c(x, dtype):
     """
     Direct calculation using scipy.
     """
-    from scipy.special import j1
+    from scipy.special import j1 as J1
     x = np.asarray(x, dtype)
-    return np.asarray(2, dtype)*j1(x)/x
+    return np.asarray(2, dtype)*J1(x)/x
 
-def cephes_j1c(x, dtype, n):
+def cephes_J1c(x, dtype, n):
     """
     Calculation using pade approximant.
     """
+    f = np.float64 if np.dtype(dtype) == np.float64 else np.float32
     x = np.asarray(x, dtype)
     ans = np.empty_like(x)
@@ -42,11 +43,11 @@
 
     # Branch a
-    a_idx = ax < 8.0
+    a_idx = ax < f(8.0)
     a_xsq = x[a_idx]**2
     a_coeff1 = list(reversed((72362614232.0, -7895059235.0, 242396853.1, -2972611.439, 15704.48260, -30.16036606)))
     a_coeff2 = list(reversed((144725228442.0, 2300535178.0, 18583304.74, 99447.43394, 376.9991397, 1.0)))
-    a_ans1 = np.polyval(a_coeff1[n:], a_xsq)
-    a_ans2 = np.polyval(a_coeff2[n:], a_xsq)
-    ans[a_idx] = 2*a_ans1/a_ans2
+    a_ans1 = np.polyval(np.asarray(a_coeff1[n:], dtype), a_xsq)
+    a_ans2 = np.polyval(np.asarray(a_coeff2[n:], dtype), a_xsq)
+    ans[a_idx] = f(2.0)*a_ans1/a_ans2
 
     # Branch b
@@ -55,14 +56,53 @@
     b_x = x[b_idx]
 
-    b_y = 64.0/(b_ax**2)
-    b_xx = b_ax - 2.356194491
+    b_y = f(64.0)/(b_ax**2)
+    b_xx = b_ax - f(2.356194491)
     b_coeff1 = list(reversed((1.0, 0.183105e-2, -0.3516396496e-4, 0.2457520174e-5, -0.240337019e-6)))
     b_coeff2 = list(reversed((0.04687499995, -0.2002690873e-3, 0.8449199096e-5, -0.88228987e-6, 0.105787412e-6)))
-    b_ans1 = np.polyval(b_coeff1[n:], b_y)
-    b_ans2 = np.polyval(b_coeff2[n:], b_y)
+    b_ans1 = np.polyval(np.asarray(b_coeff1[n:], dtype),b_y)
+    b_ans2 = np.polyval(np.asarray(b_coeff2[n:], dtype), b_y)
     b_sn, b_cn = np.sin(b_xx), np.cos(b_xx)
-    ans[b_idx] = np.sign(b_x)*np.sqrt(0.636619772/b_ax) * (b_cn*b_ans1 - (8.0/b_ax)*b_sn*b_ans2)*2.0/b_x
+    ans[b_idx] = np.sign(b_x)*np.sqrt(f(0.636619772)/b_ax) * (b_cn*b_ans1 - (f(8.0)/b_ax)*b_sn*b_ans2)*f(2.0)/b_x
 
     return ans
+
+def div_J1c(x, dtype):
+    f = np.float64 if np.dtype(dtype) == np.float64 else np.float32
+    x = np.asarray(x, dtype)
+    return f(2.0)*np.asarray([_J1(xi, f)/xi for xi in x], dtype)
+
+def _J1(x, f):
+    ax = abs(x)
+    if ax < f(8.0):
+        y = x*x
+        ans1 = x*(f(72362614232.0)
+                  + y*(f(-7895059235.0)
+                  + y*(f(242396853.1)
+                  + y*(f(-2972611.439)
+                  + y*(f(15704.48260)
+                  + y*(f(-30.16036606)))))))
+        ans2 = (f(144725228442.0)
+                  + y*(f(2300535178.0)
+                  + y*(f(18583304.74)
+                  + y*(f(99447.43394)
+                  + y*(f(376.9991397)
+                  + y)))))
+        return ans1/ans2
+    else:
+        y = f(64.0)/(ax*ax)
+        xx = ax - f(2.356194491)
+        ans1 = (f(1.0)
+                  + y*(f(0.183105e-2)
+                  + y*(f(-0.3516396496e-4)
+                  + y*(f(0.2457520174e-5)
+                  + y*f(-0.240337019e-6)))))
+        ans2 = (f(0.04687499995)
+                  + y*(f(-0.2002690873e-3)
+                  + y*(f(0.8449199096e-5)
+                  + y*(f(-0.88228987e-6)
+                  + y*f(0.105787412e-6)))))
+        sn, cn = np.sin(xx), np.cos(xx)
+        ans = np.sqrt(f(0.636619772)/ax) * (cn*ans1 - (f(8.0)/ax)*sn*ans2)
+        return -ans if (x < f(0.0)) else ans
 
 def plotdiff(x, target, actual, label):
@@ -84,10 +124,9 @@
     """
     target = np.asarray(mp_J1c(x), 'double')
-    direct = np_j1c(x, precision)
-    approx0 = cephes_j1c(x, precision, 0)
-    approx1 = cephes_j1c(x, precision, 1)
-    plotdiff(x, target, direct, 'direct '+precision)
-    plotdiff(x, target, approx0, 'cephes '+precision)
-    #plotdiff(x, target, approx1, 'reduced '+precision)
+    #plotdiff(x, target, mp_J1c(x, 11), 'mp 11 bits')
+    plotdiff(x, target, np_J1c(x, precision), 'direct '+precision)
+    plotdiff(x, target, cephes_J1c(x, precision, 0), 'cephes '+precision)
+    #plotdiff(x, target, cephes_J1c(x, precision, 1), 'cephes '+precision)
+    #plotdiff(x, target, div_J1c(x, precision), 'cephes 2 J1(x)/x '+precision)
     pylab.xlabel("qr (1/Ang)")
     if SHOW_DIFF:
@@ -117,5 +156,5 @@
 
 if __name__ == "__main__":
-    print "\n".join(str(x) for x in mp_J1c([1e-6,1e-5,1e-4,1e-3]))
+    #print "\n".join(str(x) for x in mp_J1c([1e-6,1e-5,1e-4,1e-3]))
     main()
     pylab.show()
